
This file lists the previously undocumented features available in the program.
These features may change or be discontinued at any time.  Their use is
totally unsupported.


In prime.ini you can force the program to use different filenames for 6 files.
This is in response to a user that is running security software that prevents
writing to any file with a .ini extension.  There may well be other uses.
You can also change the working directory (identical to the -W command line
argument).
	prime.ini=your_filename
	local.ini=your_filename
	worktodo.ini=your_filename
	prime.log=your_filename
	prime.spl=your_filename
	results.txt=your_filename
	WorkingDir=your_directory_name

You can change the program's behavior at various times of the day.  See
the Time= option described in the readme.txt file.

You can limit how far the program tries to factor a number.  This feature
should not be used with the Primenet server.  To prevent the factoring code
from factoring higher than 2^n, enter this in prime.ini:
	FactorOverride=n

You can force the Options/CPU dialog to display times using AM/PM or
a 24-hour clock format.  Otherwise, the program will make its best guess
as to the proper format.  Add this line to prime.ini:
	AMPM=n
where n is 1 for AM/PM formatting and n is 2 for 24-hour formatting.

You can adjust how many decimal digits of precision are displayed
in lines output to the screen.  In prime.ini enter a value between 0 and 6:
	PercentPrecision=n

You can choose whether the program uses the high resolution system clock, the
standard system clock, or the read timestamp counter instruction (RDTSC) to
time events.  By default prime95 uses the high resolution system clock if
available.  Choose one of these values for n (default is 1):
	0 - use the system clock.
	1 - use RDTSC but do not output clock counts.
	2 - use RDTSC and output clock counts.
The above values will only have an affect if a high resolution system clock
is not available.  You can force prime95 to bypass the high resolution clock
by adding 10 to one of the values above.  In prime.ini, enter
	RdtscTiming=n

You can alter the way the program outputs timings.  In prime.ini set:
	TimingOutput=n
Where n=1 for seconds with 3 digits of precision, n=2 for milliseconds
with 1 digit of precision, n=3 for milliseconds with 2 digits of precision,
n=4 for milliseconds with 3 digit of precision.

You can turn off the outputting of date and time to the screen.  In prime.ini:
	TimeStamp=0

You can have the timings that are output to the screen be cumulative
(from program restart or start of a new exponent) rather than resetting
after each screen output.  Add this line to prime.ini:
	CumulativeTiming=1

The program normally will not start any calculation until 90 seconds after
a reboot.  This is done so that your normal boot up procedure can be as
fast as possible.  You can control how long this delay is by adding this
line to prime.ini, where n is the number of seconds to sleep:
	BootDelay=n

The program supports 4 different code paths for LL testing depending on
the CPU type.  It also has a few different factoring code paths.  You can
force the program to choose a specific code path by setting the proper
combination of these settings in local.ini:
	CpuSupportsRDTSC=0 or 1
	CpuSupportsCMOV=0 or 1
	CpuSupportsPrefetch=0 or 1
	CpuSupportsSSE=0 or 1
	CpuSupportsSSE2=0 or 1
	CpuSupports3DNow=0 or 1
This shouldn't be necessary though as the program uses the CPUID instruction
to see if the CPU supports these features.

The program also supports different code paths for LL testing on a Pentium 4
based on the size of the L2 cache.  You can explicitly specify the L2 cache
size although this shouldn't be necessary since the program uses the CPUID
instruction to determine the L2 cache size.  In local.ini enter:
	CpuL2CacheSize=128 or 256 or 512
	CpuL2CacheLineSize=32 or 64 or 128
	CpuL2SetAssociative=4 or 8

The program automatically computes the CPU type and speed.  The CPU type
is used to tell the server what kind of CPU you have (to display in the
reports).  The CPU type and speed is also used to calculate how much work
to get.  If the program did not correctly figure out your CPU information,
you can override the info in local.ini:
	CpuOverride=1
	CpuType=n
	CpuSpeed=s
Where n is 3=Cyrix, 4=486, 5=Pentium, 6=Pro, 7=K6, 8=Celeron, 9=P-II,
10=P-III, 11=K7, 12=P4 and s is the speed in MHz.

The program used to do factoring and P-1 testing on exponents even if
they were not the first entry in worktodo.ini.  The rationale was that
if the number had a factor, the server could be contacted and another
exponent reserved.  This avoids the possible scenario where the LL test
for the first worktodo.ini line completes, a factor is quickly found for
the second line in worktodo.ini and the computer now sits idle until
the server can be contacted.  This behavior was confusing, especially
to newcomers.  To restore this old behavior add this line to prime.ini:
	SequentialWorkToDo=0
One added benefit is time estimates in Test/Status will be more accurate
because we'll know no factors will be found and the LL test must be run.

The program will restrict how many exponents can be added to worktodo.ini.
To override this, change prime.ini:
	MaxExponents=n

By default, ECM will stop when a new factor is found for exponents above 5825.
You can have ECM always stop or always continue searching for factors by
using a value of zero or one in prime.ini:
	ContinueECM=n

You can skip the GCD in stage 1 of P-1 factoring with this prime.ini setting:
	Stage1GCD=0

You can prevent users from accessing the Test/User Information dialog box.
In prime.ini enter:
	LockUserInfo=1

You can make prime95 ping the Primenet server every time it starts up.
I don't know why you'd want to do this.  In prime.ini enter:
	PingAtStartup=1

You can have the program generate save files every n iterations.  The files
will have a .XXX extension where XXX equals the current iteration divided
by n.  In prime.ini enter:
	InterimFiles=n

You can have the program output residues every n iterations.  The default
value is the InterimFiles value.  In prime.ini enter:
	InterimResidues=n

You can force prime95 to skip the trial factoring step prior to
running a Lucas-Lehmer test.  In prime.ini add this line:
	SkipTrialFactoring=1

You can do P-1 factoring by adding lines to worktodo.ini:
	Pfactor=exponent,how_far_factored,has_been_LL_tested_once
For example, Pfactor=10000157,64,0

You can reduce the number of times worktodo.ini is read and written by
setting in prime.ini:
	WellBehavedWork=1
This only works for worktodo.ini files that contain only Factor= lines.
Only turn this on if you have BIG worktodo.ini files and each Factor=
operation does not take much time.  You must stop prime95 before manually
editing the worktodo.ini file.

In Advanced/Time, you can enter a value between 9994 and 9999 for the
exponent to run a QA script.  The QA file looks like this:
	64511,0,400,99999999,3389BC878321980A
Where the first value is the exponent, the second value is the FFT size where
zero means use the default FFT size.  The third value is the number of
iterations to run.  The fourth value is the shift count (if the shift count
is greater than the exponent a random shift count is used).  The final value
is the expected 64-bit residue.
The dialog box values between 9994 and 9999 force slightly different
code to run.  9999 and 9998 run straightforward squaring code, 9998 differs
by gathering some standard deviation data.  9997 does squarings also
but exercises the general purpose add/sub/mul routines too.  9996 does
operations typical during ECM - the final residue won't match but the
convolution error data can be useful.  9994 and 9995 probably blow up.

You can factor a range of exponents for certain factors between b1
and b2 bits inclusive.  This feature is likely to be deleted in a future
release.  Add this to your worktodo.ini file:
	AdvancedFactor=start_exponent,end_exponent,b1,b2

AdvancedFactor uses the file p0000000 as the name of the continuation file.
This causes problems if you try to run two prime95s doing Advanced/Factoring
on a dual-CPU machine from the same directory.  Add this line to prime.ini
to use a different Advanced/Factor continuation file name:
	AdvFacFileName=filename

In AdvancedFactor, a start exponent of 8888 forces reading of a file called
factors.  The program then tries to refind each factor using the
factoring code.  This is not an efficient way to verify factors as it
goes through the entire sieving process and trial factoring many
potential factors. 

In local.ini, both the DayMemory and NightMemory values can be negative
numbers meaning use all but this many megabytes.  Thus on a 128MB system
a value of -32 means the program can use 96MB of memory.

You can control which FFT sizes are tested by the torture test.  In prime.ini
you can set:
	MinTortureFFT=n
	MaxTortureFFT=m
Where n and m are in "K".  The default for n and m is 8 and 1024 which will
run tests on FFT sizes rom 8K to 1024K.  Set n to 8 and m to 16 and you will
run only small FFT sizes.  These FFTs will fit in the L2 cache and may be
more stressful to the CPU.

You can control how many minutes each FFT size is tested by the torture test.
In prime.ini set:
	TortureTime=n
The default value is 15 minutes.

You can control how much memory the torture test uses.  In prime.ini set:
	TortureMem=n
The default value is the larger of your daytime and nighttime memory settings.
If this is set to 8MB or less, then the torture test does FFTs in-place.  This
may be more stressful but could miss memory errors that only occur at a
specific physical address.

The program normally does round-off error checking every 128 iterations.
When you are testing an exponent near the limit of an FFT length, the program
does this error checking every iteration.  
	NearFFTLimitPct=value
The default value is 0.5 (if the exponent you are testing is within 0.5% of the
maximum exponent that can be tested using the current FFT length, then the
extra error checking is performed).  A value of 0.0 will turn off this extra
error checking.

When Tray Icon or No Icon is selected the "X" at the right of the title bar
will minimize rather than exit.  You can make prime95 exit if you prefer.
In prime.ini set:
	ExitOnX=1

You can change the Windows NT/2000/XP service name and service display name.
The default for both is "Prime95 Service".  In local.ini, set:
	ServiceName=your service name
	DisplayName=your service display name
You may need to turn off the "Start at Bootup" and exit, change the local.ini
file, restart prime95 and turn the "Start at Bootup" option on to make this
change effective.

The program no longer uses hard FFT crossover points.  The soft crossovers
have two adjustments in prime.ini:
	SoftCrossovers=n
	SoftCrossoverAdjust=n
The first setting controls which exponents are examined.  The default value
is 0.2.  This means that an exponent that is 0.2% above or below an FFT
crossover point are tested for the best FFT size to use.  A value of 0.0
will turn off this soft FFT crossovers feature.  The second setting
defaults to 0.000.  This controls how aggressive or conservative the program
is in selecting the best FFT size.  The program normally uses the smaller
FFT size if the average roundoff error is below a value in 0.241 to 0.243
range.  If you set SoftCrossoverAdjust to say 0.003 then the program will
use the smaller FFT size if the average roundoff error is below a value
in 0.244 to 0.246 range.  This will generate more iterations that generate
roundoff error above 0.40 warnings and a time loss returning to the previous
save file.  It also increases the chance that a deadly roundoff error
above 0.6 will occur.  On the plus side, using the smaller FFT size each
iteration will be a bit quicker.  I wouldn't set this adjustment to more
than 0.006. If you set SoftCrossoverAdjust to say -0.002, then the program
will be more conservative and use the larger FFT size more often.

Alexander Kruppa wrote some code that allows the output of ECM stage 1 to
be passed to Paul Zimmermann's more efficient GMP-ECM stage 2.  This program
is usually faster in stage 1.  You can activate this feature by entering
	GmpEcmHook=1
in prime.ini.  Then select ECM bound #2 between 1 and bound #1.  Results.txt
will contain data that can be fed to GMP-ECM for stage 2.

In rare cases, users have reported the program can interfere with the
performance of some programs such as disk defragmenters and some games.
You can pause prime95 automatically when these programs are running by
adding this line to prime.ini:
	PauseWhileRunning=prog1,prog2,prog3,etc
Note that prime95 will pause if the program name matches any part of the
running program's file name.  That is "foobar" will match "c:\foobar.exe",
"C:\FOOBAR\name.exe", and even "C:\myfoobarprog.exe".  By default, prime95
will check the list of running programs every 64 iterations, but not more
frequently than every 10 seconds.  You can adjust the time period with this
prime.ini setting:
	PauseCheckInterval=n
where n is the number of seconds between checking which programs are running.

Normally, the program will unreserve an exponent if it is scheduled to start
thirty days after the Test/Primenet Days of work to get value.  You can adjust
this interval by setting in prime.ini:
	UnreserveDays=n
where n is the number of days.  You should increase this value if you are
loading up worktodo.ini with a large amount of work and do not want any of
the work to be unreserved.

By default, Prime95 uses RAS routines to determine if your modem is connected
to the Internet.  Microsoft now prefers the InternetGetConnectedState call
in WININET.DLL.  To use this method instead of the RAS routines, add this
line to prime.ini:
	AlternateModemDetection=1

If you are running on a laptop or in a hot room and you want to slow the
program down to reduce heat, then you can add this line to prime.ini:
	Throttle=n
where n is the number of milliseconds to sleep after each iteration.

Since P-1 stage 2 runs faster with more memory available you can have the
program only run stage 2 at night when more memory is available.  In
prime.ini set:
	OnlyRunStage2WithMaxMemory=1

You can control the maximum prime.log file size.  The default is 250K.  Add
this line to prime.ini to change the default:
	MaxLogFileSize=n

You can control what type of URLs are used to contact the PrimeNet server.
In primenet.ini enter:
	UseFullURL=n
where n is 0 for use relative URLs, 1 for use full URLs, 2 for try full URL
and if an error is returned try a relative URL.  The default setting is 2.
Note that a full URL is always sent when using a proxy server.

When using a proxy server, the program sends the port number in http strings.
That is the ":80" in "http://mersenne.org:80/cgibin_text".  At least one
proxy server only works if the ":80" is not present.  In this case, set:
	SendPortNumber=0
in the primenet.ini file.

You can add additional information to the HTTP request sent to the server.
This might be useful in some tough firewall setups.  In primenet.ini enter:
	OtherGetInfo=string
where string is any text up to 256 bytes.

The benchmarking code by default only times a subset of the large FFT sizes.
In prime.ini, set
	FullBench=1
to have the benchmarking code time all of the large FFT sizes.

"AllBench=1" in prime.ini is used to time FFT implementations optimized for
other L2 cache sizes.  This is only useful during the development cycle to
find the optimal FFT implementations for each CPU type. 

